Subject: Re: WARNING (skb_gso_segment) with tg3+bridge in 2.6.27

From: "Michael Chan" <[email-masked]>
Date: Thu, 23 Oct 2008 10:13:25 -0700

On Wed, 2008-10-22 at 19:20 -0700, Herbert Xu wrote:
> What I meant is the NETIF_F_TSO6 bit vs. NETIF_F_IPV6_CSUM bit.
> My question is essentially does having the first bit always mean
> that the second bit is set.  The second bit stands for support
> of TCPv6 and UDPv6 checksum offload (which is not necessarily
> related to TSO or UFO).
> 
> The thing which I wasn't sure about is that the conditions which
> determine which one of these bits are set do not look the same
> in tg3.
> 

Yes, NETIF_F_TSO6 chips are a subset of NETIF_F_IPV6_CSUM chips.  In the
code, these 2 bits are set independently and so the relationship is not
obvious.  We should probably rearrange the code to make things more
clear.

Thanks.